-- Program name: Bmp 2 Sequence
-- Author: Guillermo Bonveh (AKA: Knixeur - Caballero Rojo - Red Knight)
-- Version: 1.1
-- Description: This utility convert BMP files into euphoria sequences. This
-- can be useful for including images inside a program.

-- v1.1 Changes by cklester
-- modified output to not exceed user-defined line length


include image.e

-- Intro

puts(1, "\n Bmp 2 Seq v1.1 - By Caballero Rojo\n")
puts(1, "   v1.1 modifications by cklester\n")

-- End of intro

atom counter
object archivo, image
sequence cm, output
cm = command_line()

procedure error(integer e)
        if e = 1 then
                puts(2,"\n\t" & cm[3] & ": couldn't open.\n")
        elsif e = 2 then
                puts(2,"\n\t" & cm[3] & ": unexpected end of file.\n")
        elsif e = 3 then
                puts(2,"\n\t" & cm[3] & ": unsupported format.\n")
        elsif e = 4 then
                puts(2,"\n\t" & cm[3] & ": unsupported extention.\n")
        elsif e = 5 then
                puts(2,"\n\t" & cm[3] & ": format don't specified.\n")
        end if
        abort(1)
end procedure

if length(cm) < 4 then -- Check if parameters are missed in command line
    puts(1,"\nSintax: ex b2s image.bmp include\n") -- If they are missed, warn
    abort(1) -- End program
end if

if find(".",cm[3]) then error(5) end if
if equal("bmp",cm[3][length(cm[3])-3..length(cm[3])]) then error(4) end if
puts(1, "\nWorking...")
image = read_bitmap(cm[3]) -- Open BMP file
        if atom(image) then
            if image = BMP_OPEN_FAILED then
                error(1)
            elsif image = BMP_UNEXPECTED_EOF then
                error(2)
            else
                error(3)
            end if
            abort(1)
        end if
archivo = open(cm[4],"w") -- Open save file
image=image[2]
puts(archivo,"global constant image = {\n")
for i = 1 to length(image) do
	output = ""
	counter = 1
	while counter <= length(image[i]) do
		output &= sprintf("%d",{image[i][counter]})
		if counter < length(image[i]) then
			output &= ","
		end if
		if counter/40 = floor(counter/40) then
			output &= "\n"
		end if
		counter += 1
	end while
	puts(archivo, "{" & output & "}")
	if i < length(image) then
		puts(archivo,",\n")
	end if

end for

puts(archivo,"\n}")
close(archivo) -- Close file
puts(1, "\nDone...\n")

